import queryString from 'querystring';
export default function createQueryCacheId(uri, options) {
  var str = (options && options.method ? options.method : 'GET') + ":" + uri;
  var body;

  if (options) {
    if (options.body) {
      if (options.body instanceof FormData) {
        body = {};
        options.body.forEach(function (value, k) {
          body[k] = value;
        });
      } else {
        body = options.body;
      }

      var bodyStr = queryString.stringify(body);

      if (bodyStr) {
        str += "@BODY:" + bodyStr;
      }
    }
  }

  return str;
}