export interface FetchMorePlan<Payload, NextPayload> extends RequestInit {
    uri: string;
    updateData: (nextData: NextPayload, prevData: Payload) => Payload;
}
interface Helpers<Payload> {
    fetchMore: <NextPayload = Payload>(fn: (currentResult: FetchHookResultBase<Payload>) => FetchMorePlan<Payload, NextPayload> | void) => void;
}
export declare type FetchHookResultBase<Payload> = {
    readonly data: Payload;
    readonly loading: boolean;
    readonly error: undefined;
} | {
    readonly data: undefined;
    readonly loading: boolean;
    readonly error: Error;
} | {
    readonly data: undefined;
    readonly loading: boolean;
    readonly error: undefined;
};
export declare type FetchHookResult<Payload> = FetchHookResultBase<Payload> & Helpers<Payload>;
export declare type UseFetchOptions = RequestInit & {
    ssr?: boolean;
    skip?: boolean;
    stackSize?: number;
};
/**
 *
 * @param uri URI to be fetched from
 * @param options It's good practice to memoize this param
 */
export default function useFetch<Payload>(uri: string, options?: UseFetchOptions): FetchHookResult<Payload>;
export {};
